//IWi͈ȉɂ܂
//https://www.petitmonte.com/bbs/answers?question_id=4448
//RichEdit  TMemo ɕύX܂
//Delphi XE10 œmFsĂ܂
//2021-05-21 ΍i
//BXA03027@nifty.ne.jp
//
//gpꍇ́Aȉݒ肵܂
//eLXgI𒆂͉s\܂񂪁AL[Abv܂̓}EXAbvŕ\܂
//
//type
//  TFormViewGrid = class(TForm)
//
//  private
//    BoolMemoShift: Boolean;
//
//procedure TFormViewGrid.SetText(Sender: TObject);
//begin
//  //Veݒ
//  Memo1.Text := '123' + #13#10 + '456' + #13#10;
//  [hbv͖
//  Memo1.WordWrap := FALSE;
//  //Zbg
//  BoolMemoShift := FALSE;
//end;
//
//procedure TFormViewGrid.Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
//begin
//  //I͈͂̍ĕ`
//  if Memo1.SelLength > 0 then
//  begin
//    BoolMemoShift := TRUE;
//  end;
//end;
//
//procedure TFormViewGrid.Memo1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
//begin
//  //I͈͂̍ĕ`
//  if BoolMemoShift = TRUE then
//  begin
//    BoolMemoShift := FALSE;
//    Memo1.Repaint;
//  end;
//end;
//
//procedure TFormViewGrid.Memo1MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
//begin
//  //I͈͂̍ĕ`
//  if Memo1.SelLength > 0 then
//  begin
//    BoolMemoShift := TRUE;
//  end;
//end;
//
//procedure TFormViewGrid.Memo1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
//begin
//  //I͈͂̍ĕ`
//  if BoolMemoShift = TRUE then
//  begin
//    BoolMemoShift := FALSE;
//    Memo1.Repaint;
//  end;
//end;

unit MemoCrLf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TMemoCrLf = class(TMemo)
  private
    FCanvas: TCanvas;
    FDarkBackColor: TColor;
    FDarkMode: Boolean;
    FCrLfColor: TColor;
    procedure WMPaint(var Msg: TWMPaint); message WM_PAINT;
    procedure WMChar(var Msg: TWMChar); message WM_CHAR;
    procedure DrawCRLFMark(Start, Stop: Integer; fErase: boolean);
    function GetTextLength: Integer;
    procedure SetDarkBackColor(Value: TColor);
    procedure SetDarkMode(Value: Boolean);
    procedure SetCrLfColor(Value: TColor);
  protected
    procedure CreateWnd; override;
    procedure DestroyWnd; override;
  public  { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function CharFromPos(X, Y: Integer): Integer;
    function LineIndex(line: Integer): Integer;
  published
    { Published 錾 }
    property CrLfColor : TColor        read  FCrLfColor
                                       write SetCrLfColor
                                       default clBlue;
    property DarkBackColor : TColor    read  FDarkBackColor
                                       write SetDarkBackColor
                                       default clBlack;
    property DarkMode : Boolean        read  FDarkMode
                                       write SetDarkMode
                                       default FALSE;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TMemoCrLf]);
end;

{ TMemoCrLf }

procedure TMemoCrLf.WMPaint(var Msg: TWMPaint);
var
  iStartPos: Integer;
  iLastPos: Integer;
  iTextLen: Integer;
begin
  //擾
  iTextLen := GetTextLength;
  //ŏɉs}[NNA
  if iTextLen > 0 then
  begin
    //擪ʒu
    iStartPos  := 0;
    //ŏIʒu
    iLastPos  := iTextLen;
    //XVONA
    DrawCRLFMark(iStartPos, iLastPos, TRUE);
  end;

  //W̏
  inherited;

  //擾
  iTextLen := GetTextLength;
  //Ōɉs}[N\
  if iTextLen > 0 then
  begin
    //擪ʒu
    iStartPos  := 0;
    //ŏIʒu
    iLastPos  := iTextLen;
    //L`
    DrawCRLFMark(iStartPos, iLastPos, FALSE);
  end;
end;

procedure TMemoCrLf.WMChar(var Msg: TWMChar);
var
  iStartPos: Integer;
  iLastPos: Integer;
  iTextLen: Integer;
begin
  //擾
  iTextLen := GetTextLength;
  //ŏɉs}[NNA
  if iTextLen > 0 then
  begin
    //擪ʒu
    iStartPos  := 0;
    //ŏIʒu
    iLastPos  := iTextLen;
    //XVONA
    DrawCRLFMark(iStartPos, iLastPos, TRUE);
  end;

  //W̏
  inherited;

  //擾
  iTextLen := GetTextLength;
  //Ōɉs}[N\
  if iTextLen > 0 then
  begin
    //擪ʒu
    iStartPos  := 0;
    //ŏIʒu
    iLastPos  := iTextLen;
    //XV̉s}[N̕\
    DrawCRLFMark(iStartPos, iLastPos, FALSE);
  end;

end;

procedure TMemoCrLf.DrawCRLFMark(Start, Stop: Integer; fErase: boolean);
var
  c: PChar;
  iPos: Integer;
  iEnd: Integer;
  lRect: LongInt;
begin
  //ݒ
  FCanvas.Font.Assign(Font);
  //ݒ
  iPos := Start;
  iEnd := Stop;

  //Text[i+1] `ŕʂƔɒx
  c := @Text[iPos];

  //\
  HideCaret(Handle);

  //s
  while iPos <= iEnd do
  begin

    case c^ of

      ^M: //Cr
      begin
        //擾
        lRect := Perform(EM_POSFROMCHAR, iPos, 0);
        //
        if fErase then
        begin
          if FDarkMode = FALSE then
          begin
            FCanvas.Brush.Color := Color;
            FCanvas.Font.Color  := Color;
            FCanvas.TextOut(LoWord(lRect), HiWord(lRect), '');
          end
          else
          begin
            FCanvas.Brush.Color := DarkBackColor;
            FCanvas.Font.Color  := DarkBackColor;
            FCanvas.TextOut(LoWord(lRect), HiWord(lRect), '');
          end;
        end
        //\
        else
        begin
          if FDarkMode = FALSE then
          begin
            FCanvas.Brush.Color := Color;
            FCanvas.Font.Color  := FCrLfColor;
            FCanvas.TextOut(LoWord(lRect), HiWord(lRect), '');
          end
          else
          begin
            FCanvas.Brush.Color := DarkBackColor;
            FCanvas.Font.Color  := FCrLfColor;
            FCanvas.TextOut(LoWord(lRect), HiWord(lRect), '');
          end;
        end;
        //CrLf̏ꍇ
        if PChar(c+1)^ = #$0A then //Lf
        begin
          Inc(c);
          Inc(iPos);
        end;
      end;

      ^J: //Lf
      begin
        //擾
        lRect := Perform(EM_POSFROMCHAR, iPos, 0);
        //
        if fErase then
        begin
          if FDarkMode = FALSE then
          begin
            FCanvas.Brush.Color := Color;
            FCanvas.Font.Color  := Color;
            FCanvas.TextOut(LoWord(lRect), HiWord(lRect), '');
          end
          else
          begin
            FCanvas.Brush.Color := DarkBackColor;
            FCanvas.Font.Color  := DarkBackColor;
            FCanvas.TextOut(LoWord(lRect), HiWord(lRect), '');
          end;
        end
        //\
        else
        begin
          if FDarkMode = FALSE then
          begin
            FCanvas.Brush.Color := Color;
            FCanvas.Font.Color  := FCrLfColor;
            FCanvas.TextOut(LoWord(lRect), HiWord(lRect), '');
          end
          else
          begin
            FCanvas.Brush.Color := DarkBackColor;
            FCanvas.Font.Color  := FCrLfColor;
            FCanvas.TextOut(LoWord(lRect), HiWord(lRect), '');
          end;
        end;
      end;

    end;
    //XV
    Inc(c);
    Inc(iPos);
  end;

  //\
  ShowCaret(Handle);
end;

constructor TMemoCrLf.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCanvas := TCanvas.Create;
end;

destructor TMemoCrLf.Destroy;
begin
  FCanvas.Free;
  inherited Destroy;
end;

procedure TMemoCrLf.CreateWnd;
begin
  inherited CreateWnd;
  FCanvas.Handle := GetDC(Handle);
end;

procedure TMemoCrLf.DestroyWnd;
begin
  ReleaseDC(Handle, FCanvas.Handle);
  inherited DestroyWnd;
end;

function TMemoCrLf.CharFromPos(X, Y: Integer): Integer;
var
  Pos: TPoint;
begin
  Pos.X := X;
  Pos.Y := Y;
  Result := Perform(EM_CHARFROMPOS, 0, LPARAM(@Pos));
end;

function TMemoCrLf.LineIndex(line: Integer): Integer;
begin
  Result := Perform(EM_LINEINDEX, line, 0);
end;

function TMemoCrLf.GetTextLength: Integer;
begin
  Result := Perform(WM_GETTEXTLENGTH, 0, 0);
end;

procedure TMemoCrLf.SetDarkBackColor(Value: Tcolor);
begin
  if Value <> FDarkBackColor then
  begin
    FDarkBackColor := Value;
    Invalidate;
  end;
end;

procedure TMemoCrLf.SetDarkMode(Value: Boolean);
begin
  if Value <> FDarkMode then
  begin
    FDarkMode := Value;
    Invalidate;
  end;
end;

procedure TMemoCrLf.SetCrLfColor(Value: Tcolor);
begin
  if Value <> FCrLfColor then
  begin
    FCrLfColor := Value;
    Invalidate;
  end;
end;

end.
