//IWi͈ȉɂ܂
//http://www.geocities.co.jp/SiliconValley-PaloAlto/8945/delphi/tip1.html
//RichEdit  TMemo ɕύX܂
//Delphi XE2 œmFsĂ܂
//2019-02-15 ΍i
//BXA03027@nifty.ne.jp

//ȉ̐ݒĂ
//ʃNXFTMemo
//NX  FTMemoExDark
//pbgy[WFSamples
//jbgt@CFMemoExDark.pas

unit MemoExDark;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

//const
  //^udȂ邽
  //iShiftX       = 12;  //11
  //iShiftX_ENTER = 15;  //11

type
  //(DelphiɂƂ)`̃NX̂߁A錾ɂĂ(TEditMarkFOwner, AOwnerŎgpĂ邽)
  //
  TEditMarks = class;
  //

  //ҏWL\̂߂̃NX:\Ɣ\̐ؑ, F, Lݒł܂B
  //
  TEditMark = class(TPersistent)
  //
  private
    FOwner: TEditMarks;
    FEnabled: Boolean;
    FColor: TColor;
    FMark: String;
    procedure SetEnabled  (Value: Boolean);
    procedure SetColor    (Value: TColor);
    procedure SetMark     (Value: String);

  public
    constructor Create(AOwner: TEditMarks);

  published
    property Enabled   : Boolean read FEnabled write SetEnabled;
    property Color     : TColor  read FColor   write SetColor    default clBlue;
    property Mark      : String  read FMark    write SetMark;
  end;

  //
  TMemoExDark = class;
  //

  //eҏWLǗNX:L, sL, ^uL, SpXy[XL
  //
  TEditMarks = class(TPersistent)
  //
  private
   FOwner:     TMemoExDark;
   FEofMark:   TEditMark;
   FCrlfMark:  TEditMark;
   FTabMark:   TEditMark;
   FSpaceMark: TEditMark;

   procedure UpdateMarker;

  public
    constructor Create(AOwner: TMemoExDark);
    destructor  Destroy; override;

  published
    property EofMark   : TEditMark read FEofMark   write FEofMark;
    property CrlfMark  : TEditMark read FCrlfMark  write FCrlfMark;
    property TabMark   : TEditMark read FTabMark   write FTabMark;
    property SpaceMark : TEditMark read FSpaceMark write FSpaceMark;

  end;

  TVScrolledEvent = procedure(Sender: TObject) of object;


  //MemoɕҏWL\@\ƁAꊇsI@\ǉNX
  //
  TMemoExDark = class(TMemo)
  //
  private
    FCanvas: TCanvas;  //ҏWL\邽߂̃LoX
    FEditMarks: TEditMarks;
    FRectEof: TRect;
    mCrlf: String;
    mTab: String;
    mSpace: String;
    mEof: String;
    pc: PWideChar;
    iTextLen: integer;

    FShiftRet: Integer;
    FShiftEof: Integer;
    FShiftTab: Integer;
    FShiftDBCS: Integer;

    FOnVScrolled: TVScrolledEvent;

    FDarkBackColor: TColor;
    FDarkMode: Boolean;

    function  GetEditRect: TRect;
    procedure DrawEditMarker;
    procedure SetFont(AFont: TFont);
    procedure WMPaint(var Msg: TWMPaint); message WM_PAINT;
//    procedure WMChar(var Msg: TWMChar); message WM_CHAR;
    procedure CMFontChange(var Msg: TMessage); message CM_FONTCHANGED;

    procedure SetShiftRet (Value: Integer);
    procedure SetShiftEof (Value: Integer);
    procedure SetShiftTab (Value: Integer);
    procedure SetShiftDBCS(Value: Integer);

    procedure CNCommand(var Message: TWMCommand); message CN_COMMAND;

    procedure SetDarkBackColor(Value: TColor);
    procedure SetDarkMode(Value: Boolean);

  protected
    procedure CreateWnd; override;
    procedure DestroyWnd; override;
    procedure DblClick; override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
//    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
//    procedure KeyPress(var Key: Char); override;
//    procedure KeyUp(var Key: Word; Shift: TShiftState); override;

    procedure VScrolled; virtual;

  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;

//    procedure ClearCrientCanvas;

  published
    property EditMarks : TEditMarks read FEditMarks write FEditMarks;

    property ShiftRet  : Integer read FShiftRet  write SetShiftRet  ;
    property ShiftEof  : Integer read FShiftEof  write SetShiftEof  ;
    property ShiftTab  : Integer read FShiftTab  write SetShiftTab  ;
    property ShiftDBCS : Integer read FShiftDBCS write SetShiftDBCS ;

    property OnVScrolled: TVScrolledEvent read FOnVscrolled write FOnVscrolled;

    property DarkBackColor : TColor read  FDarkBackColor write SetDarkBackColor default clBlack;
    property DarkMode : Boolean     read  FDarkMode      write SetDarkMode      default False;

  end;

procedure Register;

implementation

//
//TEditmark class
//
constructor TEditMark.Create(AOwner: TEditMarks);
begin
  //W̏
  inherited Create;
  //
  FOwner := AOwner;
  //ftHgF̐ݒōs
  FColor := clBlue;
end;

procedure TEditMark.SetEnabled(Value: Boolean);
begin
  if Value = FEnabled then
  begin
    Exit;
  end;
  FEnabled := Value;
  FOwner.UpdateMarker;
end;

procedure TEditMark.SetColor(Value: TColor);
begin
  if Value = FColor then
  begin
    Exit;
  end;
  FColor := Value;
  FOwner.UpdateMarker;
end;

procedure TEditMark.SetMark(Value: string);
begin
  if Value = FMark then
  begin
    Exit;
  end;
  FMark := Value;
  FOwner.UpdateMarker;
end;


//
//TEditMarks class
//
constructor TEditMarks.Create(AOwner: TMemoExDark);
begin
  //W̏
  inherited Create;

  //
  FEofMark   := TEditMark.Create(Self);
  FCrlfMark  := TEditMark.Create(Self);
  FTabMark   := TEditMark.Create(Self);
  FSpaceMark := TEditMark.Create(Self);
  //
  FOwner := AOwner;
  //
  FEofMark.Mark   := '';
  FCrlfMark.Mark  := '';
  FTabMark.Mark   := '';
  FSpaceMark.Mark := '';
end;

destructor  TEditMarks.Destroy;
begin
  //j
  FEofMark.Free;
  FCrlfMark.Free;
  FTabMark.Free;
  FSpaceMark.Free;

  //W̏
  inherited Destroy;
end;

//Invalidate: R|[lgĕ`悵܂B
//eL̕\E\̐؂ւFEL̕ύXꍇ
//UpdateMarkerĂяoĂ܂B
procedure TEditMarks.UpdateMarker;
begin
  //
  FOwner.Invalidate;
end;

//TMemoExDark
constructor TMemoExDark.Create(AOwner: TComponent);
begin
  //W̏
  inherited Create(AOwner);

  //m
  FCanvas := TCanvas.Create;
  FEditMarks := TEditMarks.Create(Self);

  //\̐ݒ
  mCrlf  := FEditMarks.CrlfMark.Mark;
  mTab   := FEditMarks.TabMark.Mark;
  mSpace := FEditMarks.SpaceMark.Mark;
  mEof   := FEditMarks.EofMark.Mark;

end;

procedure TMemoExDark.CreateWnd;
begin
  //W̏
  inherited CreateWnd;

  //m
  FCanvas.Handle := GetDC(Handle);
  //ݒ
  FCanvas.Brush.Style := bsClear;
  FCanvas.Pen.Mode    := pmCopy;
  FCanvas.Pen.Width   := 1;
  FCanvas.Font.Assign(Font);
end;

procedure TMemoExDark.DestroyWnd;
begin
  //j
  ReleaseDC(Handle, FCanvas.Handle);

  //W̏
  inherited DestroyWnd;
end;

destructor TMemoExDark.Destroy;
begin
  //j
  FEditMarks.Free;
  FCanvas.Free;

  //W̏
  inherited Destroy;
end;


procedure TMemoExDark.DrawEditMarker;
var
  iCharPos: Integer;
  iCharEndPos: Integer;
  iStartPos: Integer;
  iLastPos: integer;
  iFirstLine: Integer;
  iLastLine: Integer;
  lRect: LongInt;
begin
  //`悵Ȃ
  if (FEditMarks.EofMark.Enabled   = False) and (FEditMarks.TabMark.Enabled  = False) and
     (FEditMarks.SpaceMark.Enabled = False) and (FEditMarks.CrlfMark.Enabled = False) then
  begin
    Exit;
  end;

  //WM_PAINT while ̒Ŏ擾sƋɒ[ɒxȂ̂ŁAK while ̊OŎ擾鎖
  iTextLen := Length(Text);

  //\Ăŏs
  iFirstLine := Perform(EM_GETFIRSTVISIBLELINE, 0, 0);
  //\ĂŏIs͕\s2{ɂ
  iLastLine  := iFirstLine + (ClientHeight div (FCanvas.TextHeight('A')) * 16 div 10);

  if iLastLine > Lines.Count-1 then
  begin
    iLastLine := Lines.Count-1;
  end;

  //擪̈ʒu擾
  iStartPos := Perform(EM_LINEINDEX, iFirstLine,    0); //\̊Jns
  iLastPos  := Perform(EM_LINEINDEX, iLastLine+1,   0); //\̏Is{P

  //Jnʒu̐ݒ
  iCharPos := iStartPos;

  //{̍ŏIsȂIʒu͕̍Ō
  if iLastLine = Lines.Count-1 then
  begin
    iCharEndPos := iTextLen-1;
  end
  //̍s1O
  else
  begin
    iCharEndPos := iLastPos-1;
  end;

  //wiFݒ
  if FDarkMode = TRUE then
  begin
    FCanvas.Brush.Color := FDarkBackColor;
  end
  else
  begin
    FCanvas.Brush.Color := Color;
  end;

  //̃AhXݒ
  pc := @Text[iStartPos+1];


  //Ō܂Ŏ{
  while iCharPos <= iCharEndPos do
  begin
    //R[h𔻒
    case pc^ of

        //^u
        #$09:
        begin
          if FEditMarks.TabMark.Enabled = True then
          begin
            //擾
            lRect := Perform(EM_POSFROMCHAR, iCharPos, 0);
            if lRect >= 0 then
            begin
              //`
              FCanvas.Font.Color := FEditMarks.TabMark.Color;
              FCanvas.TextOut(LoWord(lRect) + ShiftTab - (FCanvas.TextWidth(mTab) * 8 div 10), HiWord(lRect), mTab);
            end;
          end;
        end;

        //Sp
        #$3000:
        begin
          if FEditMarks.SpaceMark.Enabled = True then
          begin
            //擾
            lRect := Perform(EM_POSFROMCHAR, iCharPos, 0);
            if lRect >= 0 then
            begin
              //`
              FCanvas.Font.Color := FEditMarks.SpaceMark.Color;
              FCanvas.TextOut(LoWord(lRect) + ShiftDBCS - FCanvas.TextWidth('M'), HiWord(lRect), mSpace);
            end;
          end;
        end;

        //s
        #$0D:
        begin
          if FEditMarks.CrlfMark.Enabled= True then
          begin
            //擾
            lRect := Perform(EM_POSFROMCHAR, iCharPos, 0);
            if lRect >= 0 then
            begin
              //`
              FCanvas.Font.Color := FEditMarks.CrlfMark.Color;
              FCanvas.TextOut(LoWord(lRect) + ShiftRet - FCanvas.TextWidth('M'), HiWord(lRect), mCrLf);
            end;
          end;
        end;

        //s
        #$0A:
        begin
          if FEditMarks.CrlfMark.Enabled = True then
          begin
            //擾
            lRect := Perform(EM_POSFROMCHAR, iCharPos, 0);
            if lRect >= 0 then
            begin
              //`
            end;
          end;
        end;

    end;

    if (FEditMarks.EofMark.Enabled = True) then
    begin
      //L͎̍sɕ\
      //ŏIʒu
      if iCharPos = (iTextLen-1) then
      begin
        //擾
        lRect := Perform(EM_POSFROMCHAR, iCharPos, 0);
        if lRect >= 0 then
        begin
          //`
          FCanvas.Font.Color := FEditMarks.EofMark.Color;
          FCanvas.TextOut(ShiftEof , HiWord(lRect) + FCanvas.TextHeight('A'), mEof);
          //EOF́̕ANCAg̈̑SƂ
          FRectEof.Left   := 0;
          FRectEof.Top    := HiWord(lRect) + FCanvas.TextHeight('A');
          FRectEof.Height := FCanvas.TextHeight(mEof);
          FRectEof.Width  := ClientWidth;
        end;
      end;
    end;

    //Z
    Inc(pc, 1);
    Inc(iCharPos, 1);
  end;

end;

procedure TMemoExDark.SetFont(AFont: TFont);
begin
  //o^
  FCanvas.Font.Assign(AFont);
end;

//MemõtHgύXƂ̃bZ[WĂяô
//FCanvas(ҏWL̃tHgAtHgTCY)ύXĂ܂B
procedure TMemoExDark.CMFontChange(var Msg: TMessage);
begin
  //W̏
  inherited;

  //ݒ
  SetFont(Font);
end;

function TMemoExDark.GetEditRect: TRect;
begin
  Perform(EM_GETRECT, 0, LPARAM(@Result));
end;

procedure TMemoExDark.WMPaint(var Msg: TWMPaint);
var
  er: TRect;
  cr: TRect;
begin
  //擾
  cr := ClientRect;
  er := GetEditRect;
  //wiFݒ
  if FDarkMode = TRUE then
  begin
    FCanvas.Brush.Color := FDarkBackColor;
  end
  else
  begin
    FCanvas.Brush.Color := Color;
  end;
  //
  if er.Left > cr.Left then
  begin
    FCanvas.FillRect(Rect(cr.Left, cr.Top, er.Left, cr.Bottom));
  end;
  if er.Top > cr.Top then
  begin
    FCanvas.FillRect(Rect(cr.Left, cr.Top, cr.Right, er.Top));
  end;
  if cr.Bottom > er.Bottom then
  begin
    FCanvas.FillRect(Rect(cr.Left, er.Bottom, cr.Right, cr.Bottom));
  end;
  if cr.Right > er.Right then
  begin
    FCanvas.FillRect(Rect(er.Right, cr.Top, cr.Right, cr.Bottom));
  end;

  if (FEditMarks.EofMark.Enabled = True) then
  begin
    //wiFݒ
    if FDarkMode = TRUE then
    begin
      FCanvas.Brush.Color := FDarkBackColor;
    end
    else
    begin
      FCanvas.Brush.Color := Color;
    end;
    //O
    FCanvas.FillRect(FRectEof);
  end;

  //W̏
  inherited;

  //L`
  DrawEditMarker;
end;

//procedure TMemoExDark.ClearCrientCanvas;
//var
//  cr: TRect;
//begin
//  //擾
//  cr := ClientRect;
//  //wiFݒ
//  if FDarkMode = TRUE then
//  begin
//    FCanvas.Brush.Color := FDarkBackColor;
//  end
//  else
//  begin
//    FCanvas.Brush.Color := Color;
//  end;
//  //NA
//  FCanvas.FillRect(cr);
//end;


//procedure TMemoExDark.WMChar(var Msg: TWMChar);
//begin
//  //W̏
//  inherited;
//end;

procedure TMemoExDark.DblClick;
begin
//͎sĂeȂ̂ŎsȂ
//  if (FEditMarks.EofMark.Enabled = True) then
//  begin
//    //O
//    FCanvas.Brush.Color := Color;
//    FCanvas.FillRect(FRectEof);
// end;

  //W̏
  inherited DblClick;

  //L`
  DrawEditMarker;
end;

procedure TMemoExDark.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
//ŏIs\Ă鎞ɁA}EX𓮍삳 EOF _ł̂ŎsȂ
//  if (FEditMarks.EofMark.Enabled = True) then
//  begin
//    //O
//    FCanvas.Brush.Color := Color;
//    FCanvas.FillRect(FRectEof);
//  end;

  //W̏
  inherited MouseMove(Shift, X, Y);

  //L`
  DrawEditMarker;
end;

//procedure TMemoExDark.KeyDown(var Key: Word; Shift: TShiftState);
//begin
//  //W̏
//  //inherited KeyDown(Key, Shift);
//end;

//procedure TMemoExDark.KeyPress(var Key: Char);
//begin
//  //W̏
//  //inherited KeyPress(Key);
//end;

//procedure TMemoExDark.KeyUp(var Key: Word; Shift: TShiftState);
//begin
//  //W̏
//  //inherited KeyUp(Key, Shift);
//end;


procedure TMemoExDark.SetShiftRet(Value: Integer);
begin
  if Value = FShiftRet then
  begin
    Exit;
  end;
  FShiftRet := Value;
end;

procedure TMemoExDark.SetShiftEof(Value: Integer);
begin
  if Value = FShiftEof then
  begin
    Exit;
  end;
  FShiftEof := Value;
end;

procedure TMemoExDark.SetShiftTab(Value: Integer);
begin
  if Value = FShiftTab then
  begin
    Exit;
  end;
  FShiftTab := Value;
end;

procedure TMemoExDark.SetShiftDBCS(Value: Integer);
begin
  if Value = FShiftDBCS then
  begin
    Exit;
  end;
  FShiftDBCS := Value;
end;



procedure TMemoExDark.VScrolled;
begin
  if Assigned(FOnVScrolled) then
  begin
    FOnVScrolled(Self);
  end;
end;

procedure TMemoExDark.CNCommand;
begin
  inherited;

  Message.Result := 0;

  if Message.NotifyCode = EN_VSCROLL then
  begin
    VSCrolled;
  end;
end;


procedure TMemoExDark.SetDarkBackColor(Value: Tcolor);
begin
  if Value <> FDarkBackColor then
  begin
    FDarkBackColor := Value;
  end;
end;

procedure TMemoExDark.SetDarkMode(Value: Boolean);
begin
  if Value <> FDarkMode then
  begin
    FDarkMode := Value;
  end;
end;


//ł̓R|[lgCXg[Ƃɂǂ̃y[WŉƂ
//Oœo^邩߂Ă܂B
procedure Register;
begin
  //o^
  RegisterComponents('Samples', [TMemoExDark]);
end;

end.
