program annsFMtext;

uses
  Vcl.Forms,
  Find in 'Find.pas' {FormFind},
  Help in 'Help.pas' {FormHelp},
  Jump in 'Jump.pas' {FormJump},
  KeyBoard in 'KeyBoard.pas' {FormKeyBoard},
  KeyMap in 'KeyMap.pas' {FormKeyMap},
  Launcher in 'Launcher.pas' {FormLauncher},
  HtSearch in 'HtSearch.pas',
  Main in 'Main.pas' {FormMain},
  SelectFiler in 'SelectFiler.pas' {FormSelectFiler},
  PageSetting in 'PageSetting.pas' {FormPageSetting},
  Log in 'Log.pas' {FormLog},
  KigouSetting in 'KigouSetting.pas' {FormKigouSetting},
  LineSetting in 'LineSetting.pas' {FormLineSetting},
  MyUtility in 'MyUtility.pas',
  FindAll in 'FindAll.pas' {FormFindAll},
  HtSearch2 in 'HtSearch2.pas',
  Vcl.Themes,
  Vcl.Styles,
  IniFiles,
  System.SysUtils,
  ViewGrid in 'ViewGrid.pas' {FormViewGrid};

{$R *.res}

function SetVCLStyle: Boolean;
var
  IniFile: TIniFile;
  sStr1: String;
begin
  Result := TRUE;

  //m
  IniFile := TIniFile.Create (System.SysUtils.ChangeFileExt(ParamStr(0), '.ini'));
  //X^C
  sStr1 := IniFile.ReadString   ('VclStyle',    'Text',   'Windows');
  //j
  IniFile.Free;

  //
  if      sStr1 = 'Windows' then
  begin
    ;
  end
  else if sStr1 = 'Carbon' then
  begin
    TStyleManager.TrySetStyle('Carbon');
  end
  else if sStr1 = 'Charcoal Dark Slate' then
  begin
    TStyleManager.TrySetStyle('Charcoal Dark Slate');
  end
  else if sStr1 = 'Windows10 Dark' then
  begin
    TStyleManager.TrySetStyle('Windows10 Dark');
  end
  else
  begin
    ;
  end;
end;

begin
  //VCLX^Cݒ
  SetVCLStyle;
  //ʏ폈
  Application.Initialize;
  Application.MainFormOnTaskbar := True;
  Application.CreateForm(TFormMain, FormMain);
  Application.CreateForm(TFormFind, FormFind);
  Application.Run;
end.

